import { apiWaypointEntity } from "../lib/apiwaypoint/waypointEntity.js"
import { world, system } from "@minecraft/server"

world.afterEvents.playerDimensionChange.subscribe(({fromDimension: oldDimension, toDimension: newDimension, player: player}) => {
    const oldWaypoints = oldDimension.getEntities({type: "wp:waypoint", tags: [`waypointOwner: ${player.id}`]})
    if(oldWaypoints) oldWaypoints.forEach(entity => entity.remove())

    system.runTimeout(() => { apiWaypointEntity.recoverWaypoints(player) }, 30)
})