import { apiWaypointInfo } from "../lib/apiwaypoint/waypointInfo.js"
import { dateType } from "../ui/configUi.js"
import { apiInfo } from "../lib/apiInfo.js"
import { world } from "@minecraft/server"

world.afterEvents.entityDie.subscribe(({deadEntity: player}) => {
    if(player.typeId != "minecraft:player") return
    const deathCount = player.getDynamicProperty("advancedWaypoint:deathCount") ?? 0
    player.setDynamicProperty("advancedWaypoint:deathCount", deathCount +1)
    const config = apiInfo.getWaypointConfig(player)
    if(config.createDeathpoint) apiWaypointInfo.createWaypoint(player, [setDate(deathCount +1, new Date(), config.deathPointDate), 7, Math.floor(Math.random() * 255), Math.floor(Math.random() * 255), Math.floor(Math.random() * 255), true], apiInfo.getAllWaypoints(player), false)
})

function setDate(deathCount, date, type){
    const order = dateType[type].replace(" - ", ":").split(":")
    const dates = []
    order.forEach(d => {
        if(d == "YY") dates.push(`${JSON.stringify(date.getFullYear()).slice(2)}`)
        if(d == "MM") dates.push(`${date.getMonth() +1}`)
        if(d != "YY" && d != "MM") dates.push(`${date[dateInfo[d]]()}`)
    })
    return `Death ${deathCount} - ${dates[0].padStart(2, "0")}:${dates[1].padStart(2, "0")}:${dates[2].padStart(2, "0")} - ${dates[3].padStart(2, "0")}/${dates[4].padStart(2, "0")}/${dates[5]}`
}

const dateInfo = {
    "ss": "getSeconds",
    "mm": "getMinutes",
    "hh": "getHours",
    "DD": "getDate",
    "MM": "getMonth",
    "YY": "getFullYear",
    "YYYY": "getFullYear"
}