import { apiWaypointEntity } from "../lib/apiwaypoint/waypointEntity.js"
import { world, system } from "@minecraft/server"
import { waypointMenu } from "../ui/mainUi.js"
import "./changeDimension.js"
import "./deathPoint.js"
import "./locator.js"

// Open the Waypoint Menu
world.beforeEvents.worldInitialize.subscribe(data => {
    data.itemComponentRegistry.registerCustomComponent("wp:use", {
        onUse: ({source: player, itemStack: item}) => {
            if(item.typeId == "wp:waypoint_item") waypointMenu(player)
            //if(item.typeId == "wp:cartography_paper"){
            //    player.getComponent("equippable").setEquipment("Mainhand", new ItemStack("wp:waypoint_item"))
            //    player.playSound("ui.cartography_table.take_result")
            //}
        }
    })
})

// Initialize & Respawn
world.afterEvents.playerSpawn.subscribe(({initialSpawn, player}) => {
    if(initialSpawn) if(!player.getDynamicProperty("waypointConfig")){
        player.setDynamicProperty("waypointConfig", JSON.stringify({
            showName: true,
            showDistance: true,
            showPos: true,
            createDeathpoint: true,
            deathPointDate: 0
        }))
    }
    system.runTimeout(() => {
        apiWaypointEntity.recoverWaypoints(player)
    }, 20 * 5)
})