import { world, Player } from "@minecraft/server"
import { apiOrganize } from "./apiOrganize.js"

export const apiInfo = new class apiInfo {
    /** @param {Player} player @remakes Get all waypoint info*/
    getAllWaypoints(player){
        const dynamics = player.getDynamicPropertyIds()
        let waypoints = []
        if(!dynamics) return waypoints
        dynamics.forEach(w => { if(w.startsWith(`waypointList${player.dimension.id}`)) waypoints.push(...JSON.parse(player.getDynamicProperty(w))) })
        return apiOrganize.organize(waypoints)
    }

    /** @param {Player} player @remakes Get waypoint settings info*/
    getWaypointConfig(player){
        return !player.getDynamicProperty("waypointConfig") ? {} : JSON.parse(player.getDynamicProperty("waypointConfig"))
    }

    saveAllPoints(player, waypoints){
        let list = waypoints
        for(let i = 0; i < Math.floor(waypoints.length / (32767 / 275)) +1; i++){
            let temp = []
            for(let i2 = 0; i2 < Math.floor(32767 / 275); i2++){
                if(!list[0]) break
                temp.push(list.shift())
            }
            player.setDynamicProperty(`waypointList${player.dimension.id}${i}`, JSON.stringify(temp))
        }
    }

    saveNewPoint(player, point, waypoints, showMenssage = true){
        const oldPoints = waypoints.length > 0 ? waypoints : []
        oldPoints.unshift(point)
        if(showMenssage) player.onScreenDisplay.setActionBar({translate: "waypoint.warning.createPoint", with: [point.id]})
        this.saveAllPoints(player, oldPoints)
    }
}